<!DOCTYPE html>

<html lang="en">
<head>
	<meta charset="utf-8">
	<meta name="viewport" content="width=device-width">
	<title>Plait Webview Docs Source: model/plaigraph.js</title>

	<!--[if lt IE 9]>
	<script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
	<![endif]-->
	<link type="text/css" rel="stylesheet" href="styles/sunlight.default.css">

	<link type="text/css" rel="stylesheet" href="styles/site.cosmo.css">

</head>

<body>

<div class="navbar navbar-default navbar-fixed-top navbar-inverse">
<div class="container">
	<div class="navbar-header">
		<a class="navbar-brand" href="index.html">Plait Webview Docs</a>
		<button class="navbar-toggle" type="button" data-toggle="collapse" data-target="#topNavigation">
			<span class="icon-bar"></span>
			<span class="icon-bar"></span>
			<span class="icon-bar"></span>
        </button>
	</div>
	<div class="navbar-collapse collapse" id="topNavigation">
		<ul class="nav navbar-nav">
			
			<li class="dropdown">
				<a href="namespaces.list.html" class="dropdown-toggle" data-toggle="dropdown">Namespaces<b class="caret"></b></a>
				<ul class="dropdown-menu ">
					<li><a href="socket.html">socket</a></li>
				</ul>
			</li>
			
			<li class="dropdown">
				<a href="classes.list.html" class="dropdown-toggle" data-toggle="dropdown">Classes<b class="caret"></b></a>
				<ul class="dropdown-menu ">
					<li><a href="Control.html">Control</a></li><li><a href="SessionControl.html">SessionControl</a></li><li><a href="Collection.html">Collection</a></li><li><a href="Overview.html">Overview</a></li><li><a href="Plugins.html">Plugins</a></li><li><a href="Editor.html">Editor</a></li><li><a href="FileMenu.html">FileMenu</a></li><li><a href="Form.html">Form</a></li><li><a href="Routing.html">Routing</a></li>
				</ul>
			</li>
			
			<li class="dropdown">
				<a href="global.html" class="dropdown-toggle" data-toggle="dropdown">Global<b class="caret"></b></a>
				<ul class="dropdown-menu ">
					<li><a href="global.html#routing">routing</a></li><li><a href="global.html#control">control</a></li><li><a href="global.html#showSessions">showSessions</a></li><li><a href="global.html#TabButton">TabButton</a></li><li><a href="global.html#CueButton">CueButton</a></li><li><a href="global.html#CueBar">CueBar</a></li><li><a href="global.html#form">form</a></li><li><a href="global.html#editor">editor</a></li><li><a href="global.html#addGame">addGame</a></li><li><a href="global.html#createGame">createGame</a></li><li><a href="global.html#removeGame">removeGame</a></li><li><a href="global.html#inputPrompt">inputPrompt</a></li><li><a href="global.html#confirmation">confirmation</a></li><li><a href="global.html#identifyBrowser">identifyBrowser</a></li><li><a href="global.html#generateUUID">generateUUID</a></li><li><a href="global.html#namespace">namespace</a></li>
				</ul>
			</li>
			
		</ul>
        
            <div class="col-sm-3 col-md-3">
                <form class="navbar-form" role="search">
                    <div class="input-group">
                        <input type="text" class="form-control" placeholder="Search" name="q" id="search-input">
                        <div class="input-group-btn">
                            <button class="btn btn-default" id="search-submit"><i class="glyphicon glyphicon-search"></i></button>
                        </div>
                    </div>
                </form>
            </div>
        
	</div>

</div>
</div>


<div class="container" id="toc-content">
<div class="row">

	
	<div class="col-md-12">
	
		<div id="main">
			

		<h1 class="page-title">Source: model/plaigraph.js</h1>
    
<section>
    <article>
        <pre
            class="sunlight-highlight-javascript linenums">/** 
 * @file plaigraph
 * @copyright Benedikt Kaffai 2020
 * @license GPLv3
 */


////////////////////////////////////////////////////
// Global Variables and Settings
////////////////////////////////////////////////////
const Swal2 = swal;
var plaigraph = {}
console.log("load graphic node UI")

plaigraph.config = gConfig;
plaigraph.form = Object.assign(plaigraph.config.jsoneditor, { schema: plaigraph.config.schema });

function setGraphSchema(schema) {
    console.log(schema)
    plaigraph.form.schema = schema
}

$paper_container = $('&lt;section id="paper-container">&lt;/section>')
$paper_mainview = $('&lt;div id="paper-mainview">&lt;/div>')
$paper_miniview = $('&lt;div id="paper-miniview">&lt;/div>')

$paper_container.append($paper_mainview)
$paper_container.append($paper_miniview)


const graph = new joint.dia.Graph;
const paper = new joint.dia.Paper({
    el: $paper_mainview.get(),  
    model: graph,
    width: plaigraph.config.paper.width,
    height: plaigraph.config.paper.height,
    gridSize: 10,
    drawGrid: true,
    background: {
        color: 'rgb(252, 252, 252)'
    },
    interactive: function (cellView, method) {
        return cellView
    }
});
paper.scale(0.9);
const minimap = new joint.dia.Paper(
    {
        el: $paper_miniview.get(), 
        model: graph,
        width: plaigraph.config.paper.width * plaigraph.config.paper.scaling,
        height: plaigraph.config.paper.height * plaigraph.config.paper.scaling,
        gridSize: 1,
        background: {
            color: 'rgba(150, 150, 150, 0.1)'
        },
        interactive: false
    });
minimap.scale(plaigraph.config.paper.scaling);

plaigraph.level = new gLevel('NEWLEVEL', graph);

// plaigraph.init = function () {
//     plaigraph.config.cues.forEach(cue => {
//         plaigraph.level.addCue(cue.content, cue.position);
//         plaigraph.level.renderLinks();
//     });
// }

plaigraph.lock = function() {
    plaigraph["locked"] = true
}

plaigraph.unlock = function() {
    plaigraph["locked"] = false
}

////////////////////////////////////////////////////
// Events
////////////////////////////////////////////////////

// doubleclick to create or update Cues
paper.on('blank:pointerdblclick', (evt, x, y) => {
    if(plaigraph.locked) {return}
    openForm({ x: x, y: y }, false);
});
paper.on('cell:pointerdblclick', (cell, x, y) => {
    let cue = plaigraph.level.getCueByKey('cell.id', cell.model.id);
    openForm(cue.position, cue);
});


//  update position of cells on pointerup event 
paper.on('element:pointerup', function (cell, evt, x, y) {
    if(plaigraph.locked) {return}
    let cue = plaigraph.level.getCueByKey('cell.id', cell.model.id);
    if (cue) {
        cue.update();
        $paper_container.trigger('change')
    }
});

// events to allow dragging of jointjs canvas 
const papercontainer = $paper_container.get(0) 
paper.on('blank:pointerdown', (evt) => {
    plaigraph.config.dragging.panning = true;
    plaigraph.config.dragging.x = evt.pageX;
    plaigraph.config.dragging.y = evt.pageY;
    $('body').css('cursor', 'move');
});
document.addEventListener('mouseup', (evt) => {
    plaigraph.config.dragging.panning = false;
    $('body').css('cursor', 'default');
}, false);
papercontainer.addEventListener('mousemove', function (evt) {
    if (plaigraph.config.dragging.panning) {
        let $this = $(this);
        let mousePos = plaigraph.config.dragging
        $this.scrollLeft($this.scrollLeft() + mousePos.x - evt.pageX);
        $this.scrollTop($this.scrollTop() + mousePos.y - evt.pageY);
        mousePos.x = evt.pageX;
        mousePos.y = evt.pageY;
    }
}, false);

////////////////////////////////////////////////////
// Callbacks
////////////////////////////////////////////////////

function openForm(position, cue) {
    let editor; // local reference to json editor object
    Swal2.fire({
        onOpen: (div) => {
            document.getElementsByClassName("swal2-actions")[0].style.zIndex = "0"; 
            footer = document.getElementsByClassName("swal2-footer")[0];
            cueDelete = footer.getElementsByTagName("button")[0];
            cueCopy = footer.getElementsByTagName("button")[1];
            cueDelete.onclick = function (event) {
                const cuename = event.target.dataset.cuename;
                // ask before cue/action deletion
                Swal2.fire({
                    type: 'error',
                    title: 'CUE LÖSCHEN',
                    text: 'Willst du diesen Cue wirklich löschen? Oder nur die Änderungen verwerfen.',
                    showCloseButton: true,
                    showCancelButton: true,
                    focusConfirm: false,
                    confirmButtonText: 'Cue löschen',
                    cancelButtonText: 'Änderungen verwerfen',
                    customClass: {
                        actions: 'actions-class'
                    },
                }).then((result) => {
                    if (result.value &amp;&amp; plaigraph.level.getCue(cuename)) {
                        plaigraph.level.removeCue(cuename);
                        $paper_container.trigger('change') // CHANGE EVENT
                    }
                });
            }
            cueCopy.onclick = function (event) {
                const cuename = event.target.dataset.cuename;
                // ask before cue/action deletion
                Swal2.fire({
                    type: 'question',
                    title: 'CUE KOPIEREN',
                    text: `Willst du den Cue ${cuename} kopieren?`,
                    showConfirmButton: true,
                    showCancelButton: true,
                    confirmButtonText: 'Cue kopieren',
                    // timer: 1000
                    preConfirm: () => {
                        new Promise((resolve, reject) => {
                            const errors = editor.validate();
                            const name = editor.getValue()['name'];
                            if (errors.length) {
                                reject(errors);
                            }
                            else if (plaigraph.level.getCue(name) &amp;&amp; cue.name != name) {
                                reject("Cue Name bereits vergeben");
                            }
                            else {
                                resolve();
                            }
                        }).catch(error => {
                            Swal2.showValidationMessage(`Da ist noch ein Fehler im Formular. ${JSON.stringify(error)}`)
                        })
                    }
                }).then((result) => {
                    if (result.value) {
                        const copyPosition = {x: position.x + 50, y: position.y - 50};
                        const cloeCue = plaigraph.level.addCue(Object.assign({}, editor.getValue(), {name: `${editor.getValue()['name']}_COPY`}), copyPosition);
                        $paper_container.trigger('change') // CHANGE EVENT
                    }
                    else if (result.dismiss == "close") {
                        console.log(result);
                    }
                    else {
                        console.log(result);
                    }
                });
            }
            div.onkeydown = function (event) {
                // Press 'F2' to save JSON EDITOR
                if (event.keyCode === 113 || (event.ctrlKey &amp;&amp; event.keyCode == 83) || (event.keyCode == 91 &amp;&amp; event.keyCode == 83)) {
                    event.preventDefault();
                    Swal2.clickConfirm();
                }
            };
            const container = document.getElementById('form-container');
            editor = new JSONEditor(container, plaigraph.form);
            editor.on('ready', () => {
                if (cue) { editor.setValue(cue.data); }
                if(plaigraph.locked) {editor.disable()}
            });
        },
        html: '&lt;div id="form-container">',
        width: '80%',
        showCloseButton: true,
        showCancelButton: true,
        focusConfirm: true,
        allowOutsideClick: false,
        allowEnterKey: true,
        confirmButtonText: 'Cue speichern',
        cancelButtonText: 'Eingaben verwerfen',
        footer: `&lt;button style="color:darkred; background-color:white; border:none;" onclick='deleteCue(${cue.name})' data-cuename=${cue.name}>Cue löschen&lt;/button> &lt;button style="color:darkgreen; background-color:white; border:none;" onclick='copyCue(${cue.name})' data-cuename=${cue.name}>Cue kopieren&lt;/button>`,
        preConfirm: () => {
            new Promise((resolve, reject) => {
                const errors = editor.validate();
                const name = editor.getValue()['name'];
                if (errors.length) {
                    reject(errors);
                }
                else if (plaigraph.level.getCue(name) &amp;&amp; cue.name != name) {
                    reject("Cue Name bereits vergeben");
                }
                else {
                    resolve();
                }
            }).catch(error => {
                Swal2.showValidationMessage(`Da ist noch ein Fehler im Formular. ${JSON.stringify(error)}`)
            })
        }
    }).then((result) => {
        if (result.value) {
            // remove original cue on update and render new one
            if (cue) plaigraph.level.removeCue(cue.name);
            plaigraph.level.addCue(editor.getValue(), position);
            $paper_container.trigger('change') // CHANGE EVENT
        }
        else if (result.dismiss == "close") {
            console.log(result);
        }
        else {
            console.log(result);
        }
    });

}</pre>
    </article>
</section>





		</div>
	</div>

	<div class="clearfix"></div>

	

</div>
</div>


    <div class="modal fade" id="searchResults">
      <div class="modal-dialog">
        <div class="modal-content">
          <div class="modal-header">
            <button type="button" class="close" data-dismiss="modal" aria-label="Close"><span aria-hidden="true">&times;</span></button>
            <h4 class="modal-title">Search results</h4>
          </div>
          <div class="modal-body"></div>
          <div class="modal-footer">
            <button type="button" class="btn btn-default" data-dismiss="modal">Close</button>
          </div>
        </div><!-- /.modal-content -->
      </div><!-- /.modal-dialog -->
    </div>


<footer>

	 | <a href='https://plaitools.gitlab.io/documentation/plaiframe/'>Plaiframe Documentation</a> | <a href='https://plaitools.gitlab.io/documentation/plaiframe/plugins/'>Plugin Documentation</a> | <a href='https://gitlab.com/plaitools'>Plaitools on Gitlab</a>


	<span class="copyright">
	© 2020 Lasse Marburg, Benedikt Kaffai
	</span>

<span class="jsdoc-message">
	Documentation generated by <a href="https://github.com/jsdoc3/jsdoc">JSDoc 3.6.4</a>
	
		on Fri Feb 5th 2021
	
	using the <a href="https://github.com/docstrap/docstrap">DocStrap template</a>.
</span>
</footer>

<script src="scripts/docstrap.lib.js"></script>
<script src="scripts/toc.js"></script>

    <script type="text/javascript" src="scripts/fulltext-search-ui.js"></script>


<script>
$( function () {
	$( "[id*='$']" ).each( function () {
		var $this = $( this );

		$this.attr( "id", $this.attr( "id" ).replace( "$", "__" ) );
	} );

	$( ".tutorial-section pre, .readme-section pre, pre.prettyprint.source" ).each( function () {
		var $this = $( this );

		var example = $this.find( "code" );
		exampleText = example.html();
		var lang = /{@lang (.*?)}/.exec( exampleText );
		if ( lang && lang[1] ) {
			exampleText = exampleText.replace( lang[0], "" );
			example.html( exampleText );
			lang = lang[1];
		} else {
			var langClassMatch = example.parent()[0].className.match(/lang\-(\S+)/);
			lang = langClassMatch ? langClassMatch[1] : "javascript";
		}

		if ( lang ) {

			$this
			.addClass( "sunlight-highlight-" + lang )
			.addClass( "linenums" )
			.html( example.html() );

		}
	} );

	Sunlight.highlightAll( {
		lineNumbers : true,
		showMenu : true,
		enableDoclinks : true
	} );

	$.catchAnchorLinks( {
        navbarOffset: 10
	} );
	$( "#toc" ).toc( {
		anchorName  : function ( i, heading, prefix ) {
			return $( heading ).attr( "id" ) || ( prefix + i );
		},
		selectors   : "#toc-content h1,#toc-content h2,#toc-content h3,#toc-content h4",
		showAndHide : false,
		smoothScrolling: true
	} );

	$( "#main span[id^='toc']" ).addClass( "toc-shim" );
	$( '.dropdown-toggle' ).dropdown();

    $( "table" ).each( function () {
      var $this = $( this );
      $this.addClass('table');
    } );

} );
</script>



<!--Navigation and Symbol Display-->


<!--Google Analytics-->



    <script type="text/javascript">
        $(document).ready(function() {
            SearcherDisplay.init();
        });
    </script>


</body>
</html>
